//+------------------------------------------------------------------+
//|                                                        JR200.mq4 |
//|                            Copyright  2009, David KheongHo Lai. |
//|                                   http://davidke20.blogspot.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, David KheongHo Lai"
#property link      "davidke20.blogspot.com"

extern int    TakeProfit   = 0;
extern int    StopLoss     = 0;
extern double Lots         = 0.1;
extern double TrailingStop = 10;
extern int    MaxTrades    = 1;
extern int    MA_Fast      = 2;
extern int    Fast_shift   = 0;
extern int    Fast_Method  = 3;
extern int    MA_Slow      = 4;
extern int    Slow_shift   = 0;
extern int    Slow_Method  = 3;
extern int    MovingAverage= 200;
extern int    MA_Type      = 1;
extern bool   ReverseSignal= false;
extern int    MagicNumber  = 772188;

datetime TimeStamp=0;
bool Buy=false,Sell=false;
int init()
{
   if(Digits==3 || Digits==5)
   StopLoss=StopLoss*10;
   TakeProfit=TakeProfit*10;
   TrailingStop=TrailingStop*10;
return(0);
}
int deinit(){return(0);}


int TotalOrders(int OrdersMagic)
{
   int Total=0;
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==OrdersMagic)
      Total++;
   }
   return(Total);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int cnt;
   double sl,tp;

   if(Bars<MovingAverage)
   {
      Comment("History data less than "+MovingAverage+", kindly download from history centre and restart EA");
      return(0);  
   }

   Buy=false;
   Sell=false;

   double FastCur=iMA(NULL,0,MA_Fast,Fast_shift,Fast_Method,PRICE_CLOSE,0);
   double SlowCur=iMA(NULL,0,MA_Slow,Slow_shift,Slow_Method,PRICE_CLOSE,0);
   double SlowPre=iMA(NULL,0,MA_Slow,Slow_shift,Slow_Method,PRICE_CLOSE,1);
   double MACur=iMA(NULL,0,MovingAverage,0,MA_Type,PRICE_CLOSE,0);
   double MAPre=iMA(NULL,0,MovingAverage,0,MA_Type,PRICE_CLOSE,1);

   if(TotalOrders(MagicNumber)<MaxTrades && TimeStamp!=iTime(NULL,0,0))
   {
      if(AccountFreeMargin()<(1000*Lots))
        {
         Comment("No money. Kindly top up account or change to a smaller lot size. Account free margin = ", AccountFreeMargin());
         return(0);  
        }
      if(FastCur>SlowCur && FastCur>SlowPre && SlowCur>MACur && SlowPre<=MAPre)
      {
         if(!ReverseSignal)
         {
            Buy=true;
            Sell=false;
         }
         else
         {
            Sell=true;
            Buy=false;
         }
      }
      if(FastCur<SlowCur && FastCur<SlowPre && SlowCur<MACur && SlowPre>=MAPre)
      {
         if(!ReverseSignal)
         {
            Buy=false;
            Sell=true;
         }
         else
         {
            Sell=false;
            Buy=true;
         }
      }

      if(Buy && !Sell)
      {
         if(TakeProfit>10)tp=Ask+TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Bid-StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sl,tp,"JohnRay200",MagicNumber,0,DodgerBlue)==-1)
         Print("Error opening BUY order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }

      if(Sell && !Buy)
      {
         if(TakeProfit>10)tp=Bid-TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Ask+StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sl,tp,"JohnRay200",MagicNumber,0,FireBrick)==-1)
         Print("Error opening SELL order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }
   }

      for(cnt=0;cnt<OrdersTotal();cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
               {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                }
               }
            }
            if(OrderType()==OP_SELL)
            {                 
              if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
              {
               if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
               }
              }
            }
         }
      }

   return(0);
}